-- Ring Escape v1.4
-- Spend Rings to escape Spinouts and Tumbles!

addHook("PlayerSpawn", function(player)
	player.spindashInput = false
	player.canEscape = false
	player.tumbleDash = false
end)

addHook("PreThinkFrame", function(player)
	for player in players.iterate do
		if player.cmd.buttons == (BT_DRIFT|BT_ACCELERATE|BT_BRAKE) then
			-- player is using spindash input
			player.spindashInput = true
		else
			player.spindashInput = false
		end
	end
end)

addHook("ThinkFrame", function(player)
	for player in players.iterate do
		if player.spindashInput and player.rings > 0 and player.turbine == 0 then
			if player.spinouttimer > 5 then
				player.canEscape = true
			elseif player.tumblebounces > 0 and player.tumbleheight > 10 then
				player.canEscape = true
				player.tumbleDash = true
			else
				player.canEscape = false
				player.tumbleDash = false
			end
			if player.canEscape == true then
				player.spinouttimer = 0
				player.wipeoutslow = 0
				if player.flashing > 0 then
					player.flashing = player.flashing / 2
				end
				if player.tumbleDash == true then
					player.tumblebounces = 0
					player.tumbleheight = 0
					P_InstaThrust(player.mo, player.mo.angle, 50 * mapheaderinfo[gamemap].mobj_scale)
					-- stop all other momentum and push the player forward
					player.mo.momz = 5 * mapheaderinfo[gamemap].mobj_scale -- give them a hop too
					player.tumbleDash = false
				end
				player.rings = player.rings - 10
				S_StartSound(player.mo, sfx_s1c3)
				player.canEscape = false
			end
		end
	end
end)

-- made by NikoReiesu
-- big thanks to the kart krew discord, especially to the guys in #graphics-lua-misc who had to put up with my big dummy ass